#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire200three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire200three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three2004xi    
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three2004xi = {
                1:'0x0y-199z',
                2:'0x194y-48z',
                3:'0x1y-199z',
                4:'0x3y-199z',
                5:'0x47y-194z',
                6:'0x5y-199z',
                7:'0x7y-199z',
                8:'105x130y-109z',
                9:'107x142y-89z',
                10:'107x166y-26z',
                11:'108x154y-66z',
                12:'10x194y-46z',
                13:'10x8y-199z',
                14:'112x125y-107z',
                15:'115x137y-87z',
                16:'116x149y-65z',
                17:'116x160y-24z',
                18:'119x120y-106z',
                19:'11x167y-108z',
                20:'11x20y-198z',
                21:'11x53y-192z',
                22:'123x132y-86z',
                23:'124x143y-63z',
                24:'125x154y-22z',
                25:'126x114y-104z',
                26:'12x8y-199z',
                27:'130x126y-84z',
                28:'132x136y-61z',
                29:'133x108y-102z',
                30:'133x147y-20z',
                31:'137x119y-82z',
                32:'139x101y-101z',
                33:'139x130y-59z',
                34:'13x22y-198z',
                35:'140x140y-18z',
                36:'144x112y-80z',
                37:'146x123y-57z',
                38:'148x133y-16z',
                39:'14x54y-191z',
                40:'150x105y-78z',
                41:'153x115y-55z',
                42:'155x125y-14z',
                43:'159x107y-53z',
                44:'15x180y-85z',
                45:'15x22y-198z',
                46:'161x117y-12z',
                47:'173x0y-99z',
                48:'17x0y-199z',
                49:'17x55y-191z',
                50:'18x23y-197z',
                51:'1x2y-199z',
                52:'1x9y-199z',
                53:'20x167y-107z',
                54:'20x193y-44z',
                55:'20x24y-197z',
                56:'21x56y-190z',
                57:'23x24y-197z',
                58:'25x179y-83z',
                59:'25x57y-189z',
                60:'26x24y-196z',
                61:'28x24y-196z',
                62:'28x57y-189z',
                63:'29x167y-105z',
                64:'2x11y-199z',
                65:'2x166y-110z',
                66:'2x49y-193z',
                67:'30x193y-42z',
                68:'31x24y-196z',
                69:'32x57y-188z',
                70:'34x179y-81z',
                71:'34x23y-195z',
                72:'36x57y-188z',
                73:'38x166y-103z',
                74:'3x13y-199z',
                75:'3x4y-199z',
                76:'40x191y-40z',
                77:'40x56y-187z',
                78:'44x177y-79z',
                79:'44x56y-186z',
                80:'47x165y-101z',
                81:'49x55y-185z',
                82:'4x15y-199z',
                83:'4x5y-199z',
                84:'50x189y-38z',
                85:'53x176y-78z',
                86:'53x53y-185z',
                87:'56x163y-100z',
                88:'57x149y-119z',
                89:'57x52y-184z',
                90:'5x50y-193z',
                91:'60x187y-36z',
                92:'61x50y-183z',
                93:'63x173y-76z',
                94:'65x147y-117z',
                95:'65x161y-98z',
                96:'65x48y-182z',
                97:'69x45y-181z',
                98:'6x16y-199z',
                99:'6x179y-87z',
                100:'6x6y-199z',
                101:'70x183y-34z',
                102:'72x170y-74z',
                103:'73x145y-116z',
                104:'73x158y-96z',
                105:'73x227y-181z',
                106:'7x18y-199z',
                107:'7x52y-192z',
                108:'80x180y-32z',
                109:'81x142y-114z',
                110:'81x167y-72z',
                111:'82x155y-94z',
                112:'89x138y-112z',
                113:'89x176y-30z',
                114:'8x7y-199z',
                115:'90x163y-70z',
                116:'91x151y-93z',
                117:'97x134y-111z',
                118:'98x171y-28z',
                119:'99x147y-91z',
                120:'99x159y-68z',
                121:'9x19y-198z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire200three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire200three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE200THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE200THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE200THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE200THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE200THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three2004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE200THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE200THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE200THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three2004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three8shot2three2004xi</nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE200THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE200THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE200THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire200three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                